<?php
/**
 * stl to png conversion script by Tman
 * 
 * Requirements:
 * povray
 * stl2pov
 * render.pov (should be in the same directory as this file)
 * 
 * How to install these (tested on Kubuntu):
 * download povray-3.5 and install it (http://packages.ubuntu.com/dapper/povray-3.5)
 * install gcc (sudo apt-get install gcc)
 * download and extract stl2pov (http://www.xs4all.nl/~rsmith/software/#stl2pov)
 * open MakeFile
 * uncomment CC = gcc
 * use the make command when you are in the correct directory to compile the program
 * it didn't work for me so i changed this:
 *  -instead of the include, i just placed everything in the include in Makefile
 *  -i put the following 2 lines in comment:.if !defined(NOPORTDOCS) and .endif
 * then make did work, so it got compiled
 * when its compiled, use "sudo make install" to install it
 */

$filename="/home/tman/Documents/test.stl";
$output = "render.png";

//Convert the stl to an includable file for povray
exec("stl2pov -s $filename > render.inc");

//Rename the model in the newly created .inc file to MODELNAME
$contents = file_get_contents('render.inc');
$startReplacing = strpos($contents, '#declare');
$stopReplacing = strpos($contents, '{', $startReplacing);
$toReplace=substr($contents, $startReplacing, $stopReplacing-$startReplacing);
$contents = str_replace($toReplace, '#declare MODELNAME = mesh ', $contents);
$handle=fopen('render.inc', 'w');
fwrite($handle, $contents);
fclose($handle);

//Render the file
exec("povray -i\"render.pov\" +W600 +H600 -o\"$output\" +GA -D");

//Delete the include-file
unlink('render.inc');

//Show the result
print "image: <br /><img src='render.png' />";
?>
